CabinCamBounceMod = {}

function CabinCamBounceMod:loadMap(name)
    -- Initialize variables
    self.cameraNode = nil
    self.bounceIntensity = 0.002 -- Adjust this for how much bouncing you want
    self.maxBounce = 0.05 -- Maximum up and down movement
end

function CabinCamBounceMod:update(dt)
    -- Get the player's current vehicle
    local vehicle = g_currentMission.controlledVehicle
    if vehicle ~= nil then
        -- Check if the player is inside the vehicle and the camera is in first-person (inside the cabin)
        if g_currentMission:getIsCameraActive() and vehicle.spec_enterable.isInside then
            -- If camera is not already assigned, assign it
            if self.cameraNode == nil then
                self.cameraNode = vehicle.spec_enterable.cameras[1].cameraNode
            end

            -- Get the vehicle speed
            local speed = vehicle:getLastSpeed() * 0.036  -- Convert from m/s to km/h
            local bounce = math.sin(g_currentMission.time / 100) * self.bounceIntensity * speed

            -- Limit the bounce to the maxBounce value
            bounce = math.min(math.max(bounce, -self.maxBounce), self.maxBounce)

            -- Apply the bounce effect to the camera's Y position
            local x, y, z = getTranslation(self.cameraNode)
            setTranslation(self.cameraNode, x, y + bounce, z)
        end
    end
end

addModEventListener(CabinCamBounceMod)
